# Code Instruction for SeCA in Multi-Agent Particle Environment

## Dependencies

The code is running with Python (3.6.13) and Pytorch (1.8.1).

To enable the experimantal environments, please install OpenAI Gym (0.10.5) and Numpy (1.19.2).

To use Tensorboard to monitor the training process, please install Tensorflow (r1.14). 

After installing the related dependencies mentioned above, open the terminal and execute the following bash script:

```bash
cd environments/multiagent_particle_envs/
pip install -e .
```

## Training

The experiments on Cooperative Navigation and Prey-and-Predator mentioned in the paper are based on the implementations of [SQDDPG](https://github.com/hsvgbkhgbv/SQDDPG).

To easily run the code for training, we provide argument files for each experiment with variant methods under the directory `args` and bash script to execute the experiment with different arguments.

To train `SeCA` on the `Cooperative Navigation`(simple_spread) environment,  edit the file `simple_spread_reco.py` to change the hyperparameters. Then,  edit `train.sh` to change the variable `EXP_NAME` to `"simple_spread_reco"` and the variable `CUDA_VISIBLE_DEVICES` to the alias of the GPU you'd like to use, here such that

```bash
# !/bin/bash
# sh train.sh

EXP_NAME="simple_spread_reco"
ALIAS="_0"
export CUDA_DEVICE_ORDER=PCI_BUS_ID
export CUDA_VISIBLE_DEVICES=2

if [ ! -d "./model_save" ]
then
  mkdir ./model_save
fi

mkdir ./model_save/$EXP_NAME$ALIAS
cp ./args/$EXP_NAME.py arguments.py
python -u train.py > ./model_save/$EXP_NAME$ALIAS/exp.out &
echo $! > ./model_save/$EXP_NAME$ALIAS/exp.pid
```

If necessary, we can also edit the variable `ALIAS` to ease the experiments with different hyperparameters.
Run the experiment by the bash script such that

```bash
source train.sh
```

